// StrCalc - MCAssocImpl

#ifndef IG_STRCALC_MODULECLASS_ASSOC_IMPL_AS
#define IG_STRCALC_MODULECLASS_ASSOC_IMPL_AS

#include "Mo/abdata/mod_pvalptr.as"
#include "Mo/abdata/unor.as"
#include "Mo/abdata/alg_iter.as"

#include "MCVar.as"

#module MCAssocImpl miThis, miEnv, miPrototype, mbLocal, mMembers

#include "enum_valtype.as"

#define VAR_TEMP _stt_temp@MCAssoc
	dim VAR_TEMP

//##########################################################
//                \zE
//##########################################################
#define global assocImpl_New(%1, %2, %3) newmod %1, MCAssocImpl@, %2, %3
#define global assocImpl_Delete(%1)  delete %1

//------------------------------------------------
// \z
//------------------------------------------------
#modinit int iEnv, int bLocal
	miThis      = getaptr(thismod)
	miEnv       = iEnv
	miPrototype = (-1)		// Ȃ
	mbLocal     = bLocal
	mMembers    = new_unor()
	return miThis
	
//##########################################################
//                
//##########################################################
//------------------------------------------------
// ̕ϐ̕ϐT
// 
// @return: index or -1
//------------------------------------------------
#modcfunc assocImpl_Find str name, int bNoFindPrototype, local idx
	if ( name == "prototype" ) { return miPrototype }
	
	if ( unor_tryget( mMembers, name, idx ) ) {
		return idx
	}
	
	// prototype T
	if ( bNoFindPrototype == false && miPrototype > 0 ) {
		if ( var_GetType(miPrototype) == Valtype_Assoc ) {
			return assocImpl_Find( allInsts( var_Get(miPrototype) ), name )		// allInsts gĂ
		}
	}
	
	// Ȃ
	return -1
	
//##########################################################
//                擾
//##########################################################
//------------------------------------------------
// ϐ̐
//------------------------------------------------
#modcfunc assocImpl_Size
	return unor_size( mMembers )
	
//------------------------------------------------
// 𓾂
//------------------------------------------------
#modcfunc assocImpl_GetEnv
	return miEnv
	
#modfunc assocImpl_MoveEnv  int iEnv
	miEnv = iEnv
	return
	
//------------------------------------------------
// oϐ prototype 𓾂
// 
// @ iVar (prototype) or (-1: not have)
//------------------------------------------------
#modcfunc assocImpl_GetPrototype
	return miPrototype
	
#modcfunc assocImpl_GetPrototypeAssoc
	if ( miPrototype < 0 ) {
		return assocNull
		
	} else {
		if ( var_GetType(miPrototype) != Valtype_Assoc ) { return assocNull }
		return var_Get(miPrototype)
	}
	
#modfunc assocImpl_SetPrototype int iVar
	miPrototype = iVar
	return
	
// prototype-chain  rhs ۂ
#modcfunc assocImpl_InstOf int rhs,  local proto
	proto = assocImpl_GetPrototypeAssoc(thismod)
	if ( proto == assocNull ) { return (rhs == assocNull) }
	if ( proto == rhs ) { return true }			// v
	return assocImpl_InstOf( assoc_allInsts(proto), rhs )	// !assoc_allInsts
	
//------------------------------------------------
// ǏAẑ
//------------------------------------------------
#modcfunc assocImpl_IsLocal
	return mbLocal
	
//------------------------------------------------
// QƉ\ȕϐ̃Xg
// 
// @  this == var_GetAssoc(iVar) ȂuLvB
//------------------------------------------------
#modfunc assocImpl_GetMembers array varlist, array namelist,  local len, local it
	len = unor_size( mMembers )
	
	IterateBegin mMembers, unor, it
		namelist(IterateCnt) = it
		unor_getv mMembers, it, varlist(IterateCnt)
	IterateEnd
	
	return len
	
//##########################################################
//                `
//##########################################################
//------------------------------------------------
// ϐ`
// 
// @ prototype Œ`Ă override B
// @return = int : ϐID
//------------------------------------------------
#define global assocImpl_DefVar(%1, %2 = name, %3 = 0, %4 = Valtype_Int) VAR_TEMP@MCAssocImpl = (%3) : assocImpl_DefVar_ %1, %2, VAR_TEMP@MCAssocImpl, %4
#modfunc assocImpl_DefVar_ str name, var defval, int valtype,  local iVar
	if ( name == "prototype" ) {
		if ( miPrototype < 0 ) {
			var_New name, defval, valtype, miThis
			miPrototype = stat
		}
		return miPrototype
	}
	
	if ( assocImpl_Find(thismod, name, true) >= 0 ) { return stat }
	
	// ϐ`
	var_New name, defval, valtype, miThis
	iVar = stat
	
	unor_add mMembers, name, iVar
	
	return iVar
	
//------------------------------------------------
// ϐQƉ\ɂ
//------------------------------------------------
#modfunc assocImpl_ImportVar str name, int iVar
	
	if ( name == "prototype" ) {
		miPrototype = iVar
		return miPrototype
	}
	
	if ( assocImpl_Find(thismod, name, true) >= 0 ) { return stat }		// 
	
	unor_add mMembers, name, iVar
	
	return iVar
	
//------------------------------------------------
// ϐ
//------------------------------------------------
#modfunc assocImpl_UndefVar str name,  local idx
	
	if ( name == "prototype" ) {
		miPrototype = (-1)
		return
	}
	
	unor_remove mMembers, name
	return
	
//------------------------------------------------
// A
// 
// @ src ̊evf}[W
//------------------------------------------------
#modfunc assocImpl_Chain var src,  local varlist, local namelist
	assocImpl_GetMembers src, varlist, namelist
	repeat stat
		assocImpl_ImportVar thismod, namelist(cnt), varlist(cnt)
	loop
	return
	
#global

#endif

