// StrCalc - MCBlockImpl

#ifndef IG_STRCALC_MODULECLASS_BLOCK_IMPL_AS
#define IG_STRCALC_MODULECLASS_BLOCK_IMPL_AS

#include "Mo/abdata/mod_pvalptr.as"
#include "Mo/abdata/queue.as"
#include "Mo/abdata/list.as"

#include "MCEnv.as"

#module MCBlockImpl miThis, miEnv, mType, mQueue, mIdentlist, msExpr, mEvaler

#include "header_inner.as"

#define VAR_TEMP _stt_temp@MCBlockImpl
	dim VAR_TEMP

#enum BlockType_Code = 0
#enum BlockType_String			// RpCx
#enum BlockType_MAX

#define NeedCompile if ( mType == BlockType_String ) { blockImpl_Compile thismod }

//##########################################################
//                \zE
//##########################################################
#define global blockImpl_New(%1, %2) newmod %1, MCBlockImpl@, %2
#define global blockImpl_Delete(%1)  delete %1

//------------------------------------------------
// \z
//------------------------------------------------
#modinit int iEnv
	miThis     = getaptr(thismod)
	miEnv      = iEnv
	msExpr     = ""
	mType      = BlockType_String
	return miThis
	
#modfunc blockImpl_initAsCode array tkQueue,  local tmp
	mQueue     = new_queue(), new_queue()		// s
	mIdentlist = new_list()
	mType      = BlockType_Code
	
	if ( tkQueue != 0 ) {
		repeat list_size( tkQueue(0) )
			list_getv Queue_peek(tkQueue(0), cnt), tmp
			blockImpl_Pushv thismod, tmp, list_get(tkQueue(1), cnt)
		loop
	}
	return
	
#modfunc blockImpl_initAsString str expr
	msExpr = expr
	mType  = BlockType_String
	return
	
//##########################################################
//                
//##########################################################
//------------------------------------------------
// ̎ʎqT
// 
// @return: index or -1
//------------------------------------------------
#modcfunc blockImpl_FindIdent str name, local idx
	NeedCompile
	
	idx = -1
	
	repeat list_size(mIdentlist)
		if ( list_get( mIdentlist, cnt ) == name ) {
			idx = cnt
			break
		}
	loop
	
	if ( idx >= 0 ) { return idx }
	
	return -1
	
//##########################################################
//                擾
//##########################################################
//------------------------------------------------
// 
//------------------------------------------------
#modcfunc blockImpl_GetEnv
	return miEnv
	
//------------------------------------------------
// sL[
//------------------------------------------------
#modfunc blockImpl_GetQueue array q
	NeedCompile
	
	foreach mQueue
		q(cnt) = mQueue(cnt)
	loop
	return
	
#modcfunc blockImpl_GetToken int idxlist, int idxToken
	NeedCompile
	return Queue_get( mQueue(idxlist), idxToken )
	
//------------------------------------------------
// `ʎqXg
//------------------------------------------------
#modcfunc blockImpl_GetIdentlist
	NeedCompile
	return mIdentlist
	
//------------------------------------------------
// Zuo
//------------------------------------------------
#modfunc blockImpl_GetEvaler var evaler, int iEnv
	// ĂΕԂ
	if ( vartype(mEvaler) == vartype("struct") ) {
		if ( evaler_IsYielded(mEvaler) ) {
			evaler = mEvaler
			return
		}
	}
	
	// ȂΐVK
	mEvaler = 0
	evaler_New mEvaler, miThis, iEnv
	evaler = mEvaler
	return
	
//------------------------------------------------
// (Decode) 
//------------------------------------------------
#modcfunc blockImpl_GetDecoded  local q
	blockImpl_GetQueue thismod, q
	return StrCalc_DeCompile(q)
	
//##########################################################
//                
//##########################################################
//------------------------------------------------
// RpC (񁨃R[h)
//------------------------------------------------
#modfunc blockImpl_Compile@MCBlockImpl  local tkQueue
	if ( mType == BlockType_String ) {
		StrCalc_Compile tkQueue, msExpr		// RpC
		blockImpl_initAsCode thismod, tkQueue
	}
	return
	
//------------------------------------------------
// ǉ (svf)
//------------------------------------------------
#define global blockImpl_Push(%1, %2, %3) VAR_TEMP@MCBlockImpl = (%2) : blockImpl_Pushv (%1), VAR_TEMP@MCBlockImpl, (%3)
#modfunc blockImpl_Pushv var value, int valtype
	Queue_pushv mQueue(0), value
	Queue_push  mQueue(1), valtype
	
	// `ʎq => o^
	if ( valtype == Valtype_Ident ) {
		if ( blockImpl_FindIdent(thismod, value) >= 0 ) { return }		// do^
		
		// T
		if ( env_FindVar( miEnv, value ) < 0 ) {
			list_add mIdentlist, value
		}
	}
	
	return
	
#modfunc blockImpl_PushBlock var src,  local q
	blockImpl_GetQueue src, q
	blockImpl_PushExpr thismod, q
	return
	
#modfunc blockImpl_PushExpr array q,  local value, local valtype
	
	repeat Queue_size(q(0))
		value   = Queue_get( q(0), cnt )
		valtype = Queue_get( q(1), cnt )
		blockImpl_Pushv thismod, value, valtype
	loop
	
	return
	
//------------------------------------------------
// uh
// 
// @ ̎A̎ɒuāAB
//------------------------------------------------
#modfunc blockImpl_ReplaceDerive var dst, array ptnSrc, array ptnDst,  \
	local value, local valtype, \
	local srctopValue, local srctopValtype, \
	local len, local lenPtnSrc, local lenPtnDst, \
	local idxOutside, local bReplace
	
	NeedCompile
	
	len           = Queue_size(mQueue)				// ̎吔
	lenPtnSrc     = Queue_size(ptnSrc)
	lenPtnDst     = Queue_size(ptnDst)
	srctopValue   = Queue_get( ptnSrc(0), 0 )		// uO̎̐擪
	srctopValtype = Queue_get( ptnSrc(1), 0 )		// u̎̐擪
	
;	dbgout dbgpair( srctopValue, srctopValtype )
	
	repeat len
		value   = Queue_get( mQueue(0), cnt )
		valtype = Queue_get( mQueue(1), cnt )
		
	;	dbgout dbgpair( value, valtype )
		
		// up^[̐擪ƈv
		if ( value == srctopValue && valtype == srctopValtype && lenPtnSrc <= (len - cnt) ) {
			idxOutside = cnt
			bReplace   = true
			
			// up^[Ŝƈv
			repeat lenPtnSrc - 1, 1
				bReplace &= ( Queue_get( mQueue(0), idxOutside + cnt ) == Queue_get( ptnSrc(0), cnt ) )
				bReplace &= ( Queue_get( mQueue(1), idxOutside + cnt ) == Queue_get( ptnSrc(1), cnt ) )
				if ( bReplace == false ) { break }
			loop
		}
		
		// u
		if ( bReplace ) {
			bReplace = false
			repeat lenPtnDst
				value   = Queue_get( ptnDst(0), cnt )
				valtype = Queue_get( ptnDst(1), cnt )
				blockImpl_Pushv dst, value, valtype
			;	dbgout "push: " + dbgpair(value, valtype)
			loop
			continue (cnt + lenPtnSrc)
			
		// h (ԋp鎚Ɏǉ)
		} else {
			blockImpl_Pushv dst, value, valtype
		;	dbgout "push: " + dbgpair(value, valtype)
		}
	loop
	
	return
	
//------------------------------------------------
//------------------------------------------------

#global

#endif

