// StrCalc - proc(eval) operator-s

#ifndef IG_STRCALC_PROC_EVAL_OPERATOR_AS
#define IG_STRCALC_PROC_EVAL_OPERATOR_AS

#module mod_proc_eval_op

#include "header_inner.as"

//**********************************************************
//        PZ
//**********************************************************
//------------------------------------------------
// PZ::
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni int optype, var resVt, var val, var val_vt
	if ( val_vt != Valtype_Int && val_vt != Valtype_Double ) { PutError Error_NeedInt }
	
	resVt = val_vt
	
	switch ( optype )
		// PZq::Ou
		case PrefixOp_Plus:  return val
		case PrefixOp_Minus: return (-val)
		case PrefixOp_Inv:   resVt = Valtype_Double : return (1.0 / val)
		case PrefixOp_Exp:   resVt = Valtype_Double : return expf(val)
		case PrefixOp_Sqrt:  resVt = Valtype_Double : return sqrt(val)
		case PrefixOp_Not:
			if ( val_vt != Valtype_Int ) { PutError Error_NeedInt }
			return int(val) ^ 0xFFFFFFFF
		
		// PZq::u
		case PostfixOp_Fact:    resVt = Valtype_Double : return fact_f( val )
		case PostfixOp_Percent: resVt = Valtype_Double : return (double(val) / 100.0)
	//	case PostfixOp_Call:								// ꏈ
	swend
	
	assert
	
//------------------------------------------------
// PZ::_
// 
// @ operator ! (Neg) ̂݁B
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni_Log int optype, var resVt, var val, var val_vt
	if ( val_vt != Valtype_Bool ) { PutError Error_NeedBool }
	
	resVt = Valtype_Bool
	if ( val == indet ) { return indet }		// !indet == indet
	return (val == false)
	
//------------------------------------------------
// PZ::֐
// 
// @ operator => ̂݁B
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni_Func int optype, var resVt, var val, var val_vt,  local qBlock, local cntPrms, local iFuncNew, local identlist, local prmlist
	if ( val_vt != Valtype_Block ) { PutError Error_NeedBlock }
	
	block_GetQueue val, qBlock
	
	identlist = block_GetIdentlist( val )			// `ʎqXg
	cntPrms   = list_size( identlist )
	sdim prmlist, , cntPrms
	repeat cntPrms
		prmlist(cnt) = list_get( identlist, cnt )
	loop
	
	// ֐̐ { prms: `ʎqXg, body: , env: ̐, plugin: Userdef }
	StrCalc_DefFunc block_GetEnv(val), "", cntPrms : iFuncNew = stat
	func_SetExpr iFuncNew, qBlock
	if ( cntPrms > 0 ) {
		func_SetPrmlist iFuncNew, prmlist
	}
	
	resVt = Valtype_Func
	return FuncValue( PlugIn_Userdef, iFuncNew )
	
//------------------------------------------------
// PZ::
// 
// @ Ou͕ϐAu͌̕ϐlԂB
// @prm val: iVar ̒l, val_vt == Valtype_Var (Ӓl)
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni_Assign int optype, var resVt, var val, int val_vt, int iEnv, \
	local tmp, local tmp_vt, local t
	
	tmp    = var_Get( val )				// ̕ϐl
	tmp_vt = var_GetType( val )
	
	if ( tmp_vt == Valtype_Int ) {
		switch ( optype )
			case PrefixOp_Inc:
			case PostfixOp_Inc: t =  1 : swbreak
			case PrefixOp_Dec:
			case PostfixOp_Dec: t = -1 : swbreak
		swend
		
		var_Set val, tmp + t, tmp_vt		// ϐlύX
		
	} elsif ( tmp_vt == Valtype_Assoc ) {
		tmp = StrCalc_ProcOpUni_Assoc( tmp, tmp_vt, optype, iEnv )	// ++ ܂ -- s
		
	} else {
		PutError Error_NeedInt
	}
	
	resVt = tmp_vt
	return tmp
	
//------------------------------------------------
// PZ::
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni_Block int optype, var resVt, var val, int val_vt, int iEnv, \
	local tmp
	
	assert ( val_vt == Valtype_Block )
	
;	dbgout dbgpair(val, val_vt)
	block_New       tmp, iEnv
	block_PushBlock tmp, val
	block_Push      tmp, optype, Valtype_OpUni	// Zq
	resVt = Valtype_Block
	return tmp
	
//------------------------------------------------
// PZ::Az
//------------------------------------------------
#defcfunc StrCalc_ProcOpUni_Assoc int thisAssoc, var resVt, int optype, int iEnv,  \
	local arglist, local result
	
	arglist = new_list(), new_list()			// ͋
	
	// _
	if ( optype == PrefixOp_Neg ) {
		result = StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName("Bool"), arglist, iEnv )
		return StrCalc_ProcOpUni_Log( optype, resVt, (result), (resVt) )
	}
	
	return StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName( GetName_UniOp(optype) ), arglist, iEnv )
	
// toBool
#defcfunc StrCalc_ProcOpUni_AssocToBool int thisAssoc, var resVt, int iEnv,  \
	local arglist
	
	arglist = new_list(), new_list()			// ͋
	
	return StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName("Bool"), arglist, iEnv )
	
//**********************************************************
//        񍀉Z
//**********************************************************
//------------------------------------------------
// 񍀉Z::֌W
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Relation int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt
	
	resVt = which( (optype == BinOp_Cmp), Valtype_Int, Valtype_Bool )
	
	if ( EnumRange_BinOp_RelRf(optype) ) {			// Aẑ̎QƓl
		if ( lhs_vt == Valtype_Assoc && rhs_vt == Valtype_Assoc ) {
			resVt = Valtype_Bool
			return (lhs == rhs) ^ (optype == BinOp_NeRf)
		} else {
			PutError Error_NeedAssoc
		}
	}
	
	if ( EnumRange_BinOp_Cmp(optype) && ((lhs_vt != Valtype_Int && lhs_vt != Valtype_Double) || (rhs_vt != Valtype_Int && rhs_vt != Valtype_Double)) ) {
		// 召֌W`ł̂͐lÂǂ̌^łl֌W͔ł
		PutError Error_NeedInt
	}
	
	// ӂ̌^킹
	if ( lhs_vt != rhs_vt ) {
		if ( (lhs_vt == Valtype_Double && rhs_vt == Valtype_Int) || (lhs_vt == Valtype_Int && rhs_vt == Valtype_Double) ) {
			lhs = double(lhs)
			rhs = double(rhs)
		} else {
			if ( optype == BinOp_Eq || optype == BinOp_Ne ) {
				return ( optype == BinOp_Ne )		// ^sv => Ne Ȃ^, Eq ȂU
			}
			PutError Error_NeedValtype + lhs_vt
		}
	}
	
	return StrCalc_ProcOpBin_Relation_Impl( optype, lhs, rhs )
	
#defcfunc StrCalc_ProcOpBin_Relation_Impl int optype, var lhs, var rhs
	switch ( optype )
		case BinOp_Eq:   return (lhs == rhs)
		case BinOp_Ne:   return (lhs != rhs)
		
		case BinOp_Lt:   return (lhs <  rhs)
		case BinOp_Gt:   return (lhs >  rhs)
		case BinOp_LtEQ: return (lhs <= rhs)
		case BinOp_GtEQ: return (lhs >= rhs)
		
		case BinOp_Cmp:  return sgn(lhs - rhs)
	swend
	assert
	
//------------------------------------------------
// 񍀉Z::rbg
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Bit int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt
	if ( lhs_vt != Valtype_Int || rhs_vt != Valtype_Int ) {
		PutError Error_NeedInt
	}
	resVt = Valtype_Int
	
	switch ( optype )
		case BinOp_BitAnd: return (lhs &  rhs)
		case BinOp_BitOr:  return (lhs |  rhs)
		case BinOp_BitXor: return (lhs ^  rhs)
		case BinOp_ShiftL: return (lhs << rhs)
		case BinOp_ShiftR: return (lhs >> rhs)
	swend
	
	assert
	
//------------------------------------------------
// 񍀉Z::
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt,  local result
	
	// ^`FbN
	if ( lhs_vt == Valtype_Int && rhs_vt == Valtype_Double ) {
		lhs_vt = Valtype_Double
		lhs    = double(lhs)
	} elsif ( lhs_vt == Valtype_Double && rhs_vt == Valtype_Int ) {
		rhs    = double(rhs)
	} elsif ( lhs_vt == rhs_vt && (lhs_vt == Valtype_Int || lhs_vt == Valtype_Double) ) {
		//
	} else {
		PutError Error_NeedDouble
	}
	
	resVt = lhs_vt
	
	// ZnZ
	if ( optype == BinOp_Div || optype == BinOp_Mod ) {
		// 0 ZG[̃`FbN
		if ( toIntIfCan(rhs) == 0 ) { PutError Error_DivBy0 }
	}
	
	switch ( optype )
	;	case BinOp_Split:		// ꏈ
	;	case BinOp_Set:			// ꏈ
		
		case BinOp_Add: return (lhs + rhs)
		case BinOp_Sub: return (lhs - rhs)
		case BinOp_Mul: return (lhs * rhs)
		case BinOp_Div: result = (double(lhs) / rhs) : swbreak
		case BinOp_Mod: result = (double(lhs) \ rhs) : swbreak
		
		case BinOp_Pow:
			result = which( (lhs == 0 && rhs == 0), 1, powf(lhs, rhs) )
			swbreak
		case BinOp_Root:
			if ( lhs == 0 ) {
				if ( rhs == 1 ) { resVt = Valtype_Int : return 1 }	// 0//1 = 1
				dbgout "[Error] 1ȊO0捪݂͑ȂB0//x = x^(1/0) Ȃ̂0ZG[B"
				PutError Error_DivBy0
			}
			resVt  = Valtype_Double
			result = root( rhs, lhs )		// rhs  lhs 捪
			swbreak
			
	;	case BinOp_Trans:		// ꏈ
		
		default:
			assert
	swend
	
	if ( IsDoubleIntNear(result) ) {
		resVt = Valtype_Int
		return toIntIfNear(result)
	} else {
		resVt = Valtype_Double
		return result
	}
	
//------------------------------------------------
// 񍀉Z::Az (Az)
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_AssocOrAssocBind int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, int iEnv,  \
	local result, \
	local arglist
	
	if ( rhs_vt != Valtype_Ident ) { PutError Error_NeedIdent }
	
	// (assoc).ident
	if ( lhs_vt == Valtype_Assoc ) {
		
		// oϐ̎o
		result = assoc_Find( lhs, rhs )
		resVt  = Valtype_Var
		
		if ( result < 0 ) {				// ݂Ȃʎq => ϐ𐶐
			if ( lhs == assocNull ) {	// null Q
				logmes "[Error] when 񍀉Z(Az)\nʂہI"
				PutError Error_NeedAssoc
			}
			
			assoc_DefVar lhs, rhs
			result = stat
		}
		
		// vpeB
		if ( var_GetType(result) == Valtype_Propaty ) {
			pair_setLhs var_Get(result), lhs	// vpeB this 𑩔
		}
		
		// Az : lhs  result(oϐ) 𑩔
		if ( optype == BinOp_AssocBind ) {
			rhs_vt = var_GetType(result)
			
			if ( rhs_vt == Valtype_Func || rhs_vt == Valtype_Method ) {
				rhs = var_Get(result)
				if ( rhs_vt == Valtype_Method ) { rhs = pair_getRhs(rhs) }
				
				resVt = Valtype_Method
				return new_pair( lhs, rhs )		// this 𑩔
				
			} else {
				logmes "[Error] when 񍀉Z\nAzZq̉Eӂ֐AẑłȂB"
				PutError Error_NeedFunc
			}
		}
		
	// (func).ident
	} elsif ( lhs_vt == Valtype_Func ) {
		switch ( rhs )
		;	case "body_string":  result = func_GetBodyAsString(FuncId(lhs)) : resVt = Valtype_String : swbreak
			case "apply": result = Func_System_Apply : resVt = Valtype_Func : swbreak
			case "call":  result = Func_System_Call  : resVt = Valtype_Func : swbreak
			case "bind":  result = Func_System_Bind  : resvt = Valtype_Func : swbreak
			case "new":   result = Func_System_New   : resVt = Valtype_Func : swbreak
			default:
				PutErrorMsg "֐^̓o " + swthis + " ȂB"
		swend
		
		// Az : lhs  result Ɉ
		if ( optype == BinOp_AssocBind && resvt == Valtype_Func ) {
			arglist = new_list(), new_list()		// arglist  [ lhs ]
			list_add arglist(0), lhs
			list_add arglist(1), lhs_vt
		;	result = evaler_CallOpUni_ListImpl( thismod, PostfixOp_Index, resVt, result, resVt, arglist )
			
			result = StrCalc_BindFunc( result, arglist, iEnv )
		;	resvt  = Valtype_Func		// already
		}
		
	// (method).ident
	} elsif ( lhs_vt == Valtype_Method ) {
		switch ( rhs )
			case "this": result = pair_getLhs(lhs) : resVt = Valtype_Assoc : swbreak
			case "proc": result = pair_getRhs(lhs) : resVt = Valtype_Func  : swbreak
			default:
				PutErrorMsg "\bh^̓o " + swthis + " ȂB"
		swend
		
	} else { PutError Error_NeedAssoc }
	
	return result
	
//------------------------------------------------
// 񍀉Z::
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Pair int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, int iEnv,  local result
	result = new_assoc( iEnv )
	resVt  = Valtype_Assoc
	
	assoc_DefVar result, "prototype", stt_assoc_pair, Valtype_Assoc
	assoc_DefVar result, "lhs", lhs, lhs_vt
	assoc_DefVar result, "rhs", rhs, rhs_vt
	
	return result
	
//------------------------------------------------
// 񍀉Z::
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Swap int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, int iEnv,  \
	local result, local tmp, local tmp_vt
	
	result = rhs			// XEӂ̂Ԃ
	resVt  = Valtype_Var
	
	// (l, ^) ̑g
	if ( lhs != rhs ) {		// QƓlȂȂ
		tmp = var_GetValue( lhs, tmp_vt )
		var_Set lhs, var_Get(rhs), var_GetType(rhs)
		var_Set rhs, tmp, tmp_vt
	}
	
	return result
	
//------------------------------------------------
// 񍀉Z::
//
// @ Êǂ炩A邢͗
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Block int optype, var resVt, var lhs, var lhs_vt, var rhs, var rhs_vt, int iEnv,  \
	local tmp
	
	tmp = new_block( iEnv )
	
	if ( lhs_vt == Valtype_Block && rhs_vt == Valtype_Block ) {
			block_PushBlock tmp, lhs
			block_PushBlock tmp, rhs
	} else {
		if ( lhs_vt == Valtype_Block ) {
			block_PushBlock tmp, lhs
			block_Push      tmp, rhs, rhs_vt
		} else {
			block_Push      tmp, lhs, lhs_vt
			block_PushBlock tmp, rhs
		}
	}
	
	block_Push tmp, optype, Valtype_OpBin		// Zqǉ
	resVt = Valtype_Block
	return tmp
	
//------------------------------------------------
// 񍀉Z::Az
//------------------------------------------------
#defcfunc StrCalc_ProcOpBin_Assoc int thisAssoc, var resVt, int optype, var rhs, var rhs_vt, int iEnv,  \
	local arglist, local tmp
	
	arglist = new_list(), new_list()
	list_add arglist(0), rhs
	list_add arglist(1), rhs_vt
	
	// ֌W(<> ȊO) => opCmp()  0 (stt_zero@) ̔r
	if ( EnumRange_BinOp_Rel(optype) && optype != BinOp_Cmp ) {
		tmp = StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName("Cmp"), arglist, iEnv )
		
		if ( resVt != Valtype_Int ) {
			logmes "[Error] when 񍀉Z(Az(֌W))\nopCmp()  int ԂȂ΂ȂB"
			PutError Error_NeedInt
		}
		
		resVt = Valtype_Bool
		return StrCalc_ProcOpBin_Relation_Impl( optype, tmp, stt_zero@ )		// stt_zero@ == 0
		
	// _
	} else : if ( EnumRange_BinOp_Log(optype) ) {
		dim tmp, 2
			tmp(0) = StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName("Bool"), arglist, iEnv )	// ۂ 0 ŌĂԂׂ
		if ( resVt != Valtype_Bool ) { PutError Error_NeedBool }
		
		if ( rhs_vt == Valtype_Assoc ) {		// EӂAz
			tmp(1) = StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName("Bool"), arglist, iEnv )
			if ( resVt != Valtype_Bool ) { PutError Error_NeedBool }
		} else : if ( rhs_vt == Valtype_Bool ) {
			tmp(1) = rhs
		} else {
			PutError Error_NeedBool		// ӂ Bool or Assoc (has opBool) łȂĂ͂ȂȂ
		}
		
		resVt = Valtype_Bool
		return StrCalc_ProcOpBin_Log_Impl( optype, tmp(0), tmp(1) )
		
	// ̑
	} else {
		return StrCalc_ProcOp_Assoc_Impl( thisAssoc, resVt, OpFuncName( GetName_BinOp(optype) ), arglist, iEnv )
	}
	
//------------------------------------------------
// Az̉Z (RA)
//------------------------------------------------
#defcfunc StrCalc_ProcOp_Assoc_Impl int thisAssoc, var resVt, str name, array arglist, int iEnv,  \
	local tmp, local vt, local evaler
	
	tmp = assoc_Find( thisAssoc, name )			// Z֐o
	
	if ( tmp > 0 ) {
		vt = var_GetType(tmp)
		if ( vt == Valtype_Func || vt == Valtype_Method ) {
			func_GetEvaler FuncId(var_Get(tmp)), evaler, iEnv
			return evaler_CallFuncImpl( evaler, resVt, thisAssoc, var_Get(tmp), arglist, list_size(arglist) )	// Z֐ŏ
			
		} elsif ( vt == Valtype_Block ) {
			return StrCalc_ProcBlock( thisAssoc, var_Get(tmp), resVt )
			
		} ;elsif ( vt == Valtype_Assoc )
	}
	
	logmes "[Error] Z\nAz " + thisAssoc + " ZɑΉ鉉Z֐ ." + name + " ȂB"
	resVt = Valtype_Error
	PutError Error_UnSupported

#global

#endif
